### $ANTLR 2.7.7 (20090605): "jsonpath.g" -> "JsonPathParser.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
class JsonPathError(Exception):
   pass
class Undefined(object):
   pass
undefined = Undefined()
### header action <<< 
### preamble action>>>

### preamble action <<<

### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
ROOT = 4
PATH = 5
SCHEMATYPE = 6
NAME = 7
NUMBER = 8
STRINGBLOCK = 9
NL = 10
WS = 11
CHAR = 12

class Parser(antlr.LLkParser):
    ### user action >>>
    def _root(self, token):
       raise JsonPathError("Syntax Error")
    def _path(self, token):
       raise JsonPathError("Syntax Error")
    def _schema_type(self, token):
       raise JsonPathError("Syntax Error")
    ### user action <<<
    
    def __init__(self, *args, **kwargs):
        antlr.LLkParser.__init__(self, *args, **kwargs)
        self.tokenNames = _tokenNames
        
    def parse_jsonpath(self):    
        
        r = None
        p = None
        s = None
        try:      ## for error handling
            pass
            while True:
                la1 = self.LA(1)
                if False:
                    pass
                elif la1 and la1 in [ROOT]:
                    pass
                    r = self.LT(1)
                    self.match(ROOT)
                    self._root(r)
                elif la1 and la1 in [PATH]:
                    pass
                    p = self.LT(1)
                    self.match(PATH)
                    self._path(p)
                elif la1 and la1 in [SCHEMATYPE]:
                    pass
                    s = self.LT(1)
                    self.match(SCHEMATYPE)
                    self._schema_type(s)
                else:
                        break
                    
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_0)
        
    

_tokenNames = [
    "<0>", 
    "EOF", 
    "<2>", 
    "NULL_TREE_LOOKAHEAD", 
    "ROOT", 
    "PATH", 
    "SCHEMATYPE", 
    "NAME", 
    "NUMBER", 
    "STRINGBLOCK", 
    "NL", 
    "WS", 
    "CHAR"
]
    

### generate bit set
def mk_tokenSet_0(): 
    ### var1
    data = [ 2L, 0L]
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())
    
