# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../../'))
from caty.testutil import *
from caty.jsontools.path.validator import *
from caty.jsontools.model import JsonModel
from StringIO import StringIO

def mk_schema(s):
    io = StringIO()
    io.write(s)
    io.seek(0)
    return to_decl_style(io)

class ValidatorTest(TestCase):
    def test_validate(self):
        scm = mk_schema(
        """$.foo: string;
$.bar: integer;""")
        print scm
        scm = mk_schema('$.foo.#: string')
        print scm

        scm = mk_schema(
        """$.foo: string;
$.bar: integer;
$.buz.hoge.huga: string;
$.buz.hoge.hage: string;
""")
        print scm

        scm = mk_schema(
        """$.0: string;
$.1: integer;
$.2.foo: string;
$.2.bar: string;
$.#.foo: string;
$.#.bar: string;
""")
        print scm

if __name__ == '__main__': 
    test(ValidatorTest)

