### $ANTLR 2.7.7 (20090605): "smarty.expr.g" -> "SmartyExprLexer.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
import sys
from StringIO import StringIO
### header action <<< 
### preamble action >>> 

### preamble action <<< 
### >>>The Literals<<<
literals = {}


### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
FILTER = 4
FILTER_ARGS = 5
VARIABLE = 6
INDEX = 7
LOOP_VAR = 8
LOOP_ITEM = 9
LOOP_KEY = 10
LOOP_NAME = 11
SYMBOL = 12
INC_EXPR = 13

class Lexer(antlr.CharScanner) :
    ### user action >>>
    ### user action <<<
    def __init__(self, *argv, **kwargs) :
        antlr.CharScanner.__init__(self, *argv, **kwargs)
        self.caseSensitiveLiterals = True
        self.setCaseSensitive(True)
        self.literals = literals
    
    def nextToken(self):
        while True:
            try: ### try again ..
                while True:
                    _token = None
                    _ttype = INVALID_TYPE
                    self.resetText()
                    try: ## for char stream error handling
                        try: ##for lexical error handling
                            la1 = self.LA(1)
                            if False:
                                pass
                            elif la1 and la1 in u'|':
                                pass
                                self.mFILTER(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u':':
                                pass
                                self.mFILTER_ARGS(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'$':
                                pass
                                self.mVARIABLE(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'[':
                                pass
                                self.mINDEX(True)
                                theRetToken = self._returnToken
                            else:
                                if (self.LA(1)==u'f') and (self.LA(2)==u'r') and (self.LA(3)==u'o') and (self.LA(4)==u'm') and (self.LA(5)==u' ' or self.LA(5)==u'='):
                                    pass
                                    self.mLOOP_VAR(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'i') and (self.LA(2)==u't') and (self.LA(3)==u'e') and (self.LA(4)==u'm') and (self.LA(5)==u' ' or self.LA(5)==u'='):
                                    pass
                                    self.mLOOP_ITEM(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'n') and (self.LA(2)==u'a') and (self.LA(3)==u'm') and (self.LA(4)==u'e') and (self.LA(5)==u' ' or self.LA(5)==u'='):
                                    pass
                                    self.mLOOP_NAME(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'f') and (self.LA(2)==u'i') and (self.LA(3)==u'l') and (self.LA(4)==u'e') and (self.LA(5)==u' ' or self.LA(5)==u'='):
                                    pass
                                    self.mINC_EXPR(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'k') and (self.LA(2)==u'e') and (self.LA(3)==u'y') and (self.LA(4)==u' ' or self.LA(4)==u'='):
                                    pass
                                    self.mLOOP_KEY(True)
                                    theRetToken = self._returnToken
                                elif (_tokenSet_0.member(self.LA(1))) and (True) and (True) and (True) and (True):
                                    pass
                                    self.mSYMBOL(True)
                                    theRetToken = self._returnToken
                                else:
                                    self.default(self.LA(1))
                                
                            if not self._returnToken:
                                raise antlr.TryAgain ### found SKIP token
                            ### option { testLiterals=true } 
                            self.testForLiteral(self._returnToken)
                            ### return token to caller
                            return self._returnToken
                        ### handle lexical errors ....
                        except antlr.RecognitionException, e:
                            raise antlr.TokenStreamRecognitionException(e)
                    ### handle char stream errors ...
                    except antlr.CharStreamException,cse:
                        if isinstance(cse, antlr.CharStreamIOException):
                            raise antlr.TokenStreamIOException(cse.io)
                        else:
                            raise antlr.TokenStreamException(str(cse))
            except antlr.TryAgain:
                pass
        
    def mFILTER(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = FILTER
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match('|')
        self.text.setLength(_saveIndex)
        pass
        self.mSYMBOL(False)
        _ttype = FILTER;
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSYMBOL(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = SYMBOL
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                pass
                self.matchRange(u'a', u'z')
            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                pass
                self.matchRange(u'A', u'Z')
            elif la1 and la1 in u'0123456789':
                pass
                self.matchRange(u'0', u'9')
            else:
                    break
                
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mFILTER_ARGS(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = FILTER_ARGS
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match(':')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'"':
            pass
            pass
            _saveIndex = self.text.length()
            self.match('"')
            self.text.setLength(_saveIndex)
            _cnt7= 0
            while True:
                if (_tokenSet_1.member(self.LA(1))):
                    pass
                    self.matchNot('\"')
                else:
                    break
                
                _cnt7 += 1
            if _cnt7 < 1:
                self.raise_NoViableAlt(self.LA(1))
            _saveIndex = self.text.length()
            self.match('"')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'\'':
            pass
            pass
            _saveIndex = self.text.length()
            self.match('\'')
            self.text.setLength(_saveIndex)
            _cnt10= 0
            while True:
                if (_tokenSet_2.member(self.LA(1))):
                    pass
                    self.matchNot('\'')
                else:
                    break
                
                _cnt10 += 1
            if _cnt10 < 1:
                self.raise_NoViableAlt(self.LA(1))
            _saveIndex = self.text.length()
            self.match('\'')
            self.text.setLength(_saveIndex)
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _ttype = FILTER_ARGS
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mVARIABLE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = VARIABLE
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match('$')
        self.text.setLength(_saveIndex)
        pass
        self.mSYMBOL(False)
        while True:
            if (self.LA(1)==u'.'):
                pass
                self.match(".")
                pass
                self.mSYMBOL(False)
            else:
                break
            
        _ttype = VARIABLE;
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mINDEX(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = INDEX
        _saveIndex = 0
        pass
        pass
        _saveIndex = self.text.length()
        self.match('[')
        self.text.setLength(_saveIndex)
        _cnt19= 0
        while True:
            if ((self.LA(1) >= u'0' and self.LA(1) <= u'9')):
                pass
                self.matchRange(u'0', u'9')
            else:
                break
            
            _cnt19 += 1
        if _cnt19 < 1:
            self.raise_NoViableAlt(self.LA(1))
        _saveIndex = self.text.length()
        self.match(']')
        self.text.setLength(_saveIndex)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_VAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_VAR
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match("from")
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('=')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'$':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.mVARIABLE(False)
        while True:
            if (self.LA(1)==u' '):
                pass
                _saveIndex = self.text.length()
                self.match(' ')
                self.text.setLength(_saveIndex)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_ITEM(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_ITEM
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match("item")
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('=')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.mSYMBOL(False)
        while True:
            if (self.LA(1)==u' '):
                pass
                _saveIndex = self.text.length()
                self.match(' ')
                self.text.setLength(_saveIndex)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_KEY(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_KEY
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match("key")
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('=')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.mSYMBOL(False)
        while True:
            if (self.LA(1)==u' '):
                pass
                _saveIndex = self.text.length()
                self.match(' ')
                self.text.setLength(_saveIndex)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_NAME(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_NAME
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match("name")
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('=')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.mSYMBOL(False)
        while True:
            if (self.LA(1)==u' '):
                pass
                _saveIndex = self.text.length()
                self.match(' ')
                self.text.setLength(_saveIndex)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mINC_EXPR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = INC_EXPR
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match("file")
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('=')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            _saveIndex = self.text.length()
            self.match(' ')
            self.text.setLength(_saveIndex)
        elif la1 and la1 in u'"':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _saveIndex = self.text.length()
        self.match('"')
        self.text.setLength(_saveIndex)
        _cnt51= 0
        while True:
            if (_tokenSet_1.member(self.LA(1))):
                pass
                self.matchNot('"')
            else:
                break
            
            _cnt51 += 1
        if _cnt51 < 1:
            self.raise_NoViableAlt(self.LA(1))
        _saveIndex = self.text.length()
        self.match('"')
        self.text.setLength(_saveIndex)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    

### generate bit set
def mk_tokenSet_0(): 
    ### var1
    data = [ 0L, 576460743847706622L, 0L, 0L]
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())

### generate bit set
def mk_tokenSet_1(): 
    ### var1
    data = [ -17179869185L, -1L, 0L, 0L]
    return data
_tokenSet_1 = antlr.BitSet(mk_tokenSet_1())

### generate bit set
def mk_tokenSet_2(): 
    ### var1
    data = [ -549755813889L, -1L, 0L, 0L]
    return data
_tokenSet_2 = antlr.BitSet(mk_tokenSet_2())
    
### __main__ header action >>> 
if __name__ == '__main__' :
    import sys
    import antlr
    import SmartyExprLexer
    
    ### create lexer - shall read from stdin
    try:
        for token in SmartyExprLexer.Lexer():
            print token
            
    except antlr.TokenStreamException, e:
        print "error: exception caught while lexing: ", e
### __main__ header action <<< 
