### $ANTLR 2.7.7 (20090605): "smarty.g" -> "SmartyLexer.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
import sys
from StringIO import StringIO
import SmartyExprLexer
import caty.template.core.instructions as ins
from caty.template.core.vm import Bytecode, Stack, TemplateRuntimeError
### header action <<< 
### preamble action >>> 

### preamble action <<< 
### >>>The Literals<<<
literals = {}


### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
IF = 4
IFNOT = 5
ELSEIF = 6
ELSE = 7
ENDIF = 8
FOREACH = 9
ENDFOR = 10
INCLUDE = 11
EXPR = 12
LITERAL = 13
ACTION = 14
NL = 15
COMMENT = 16
IF_EXPR = 17
FILTER = 18
FILTER_ARGS = 19
VARIABLE = 20
FOREACH_EXPR = 21
LOOP_VAR = 22
LOOP_ITEM = 23
LOOP_NAME = 24
INC_EXPR = 25
NO_ESC = 26
SYMBOL = 27

class Lexer(antlr.CharScanner) :
    ### user action >>>
    ### user action <<<
    def __init__(self, *argv, **kwargs) :
        antlr.CharScanner.__init__(self, *argv, **kwargs)
        self.caseSensitiveLiterals = True
        self.setCaseSensitive(True)
        self.literals = literals
    
    def nextToken(self):
        while True:
            try: ### try again ..
                while True:
                    _token = None
                    _ttype = INVALID_TYPE
                    self.setCommitToPath(False)
                    self.resetText()
                    try: ## for char stream error handling
                        try: ##for lexical error handling
                            if (_tokenSet_0.member(self.LA(1))):
                                pass
                                self.mLITERAL(True)
                                theRetToken = self._returnToken
                            elif (self.LA(1)==u'{'):
                                pass
                                self.mACTION(True)
                                theRetToken = self._returnToken
                            else:
                                self.filterdefault(self.LA(1))
                            
                            if not self._returnToken:
                                raise antlr.TryAgain ### found SKIP token
                            ### option { testLiterals=true } 
                            self.testForLiteral(self._returnToken)
                            ### return token to caller
                            return self._returnToken
                        ### handle lexical errors ....
                        except antlr.RecognitionException, e:
                            if not self.getCommitToPath():
                                self.consume()
                                raise antlr.TryAgain()
                            raise antlr.TokenStreamRecognitionException(e)
                    ### handle char stream errors ...
                    except antlr.CharStreamException,cse:
                        if isinstance(cse, antlr.CharStreamIOException):
                            raise antlr.TokenStreamIOException(cse.io)
                        else:
                            raise antlr.TokenStreamException(str(cse))
            except antlr.TryAgain:
                pass
        
    def mLITERAL(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LITERAL
        _saveIndex = 0
        pass
        _cnt7= 0
        while True:
            if (self.LA(1)==u'\\') and (self.LA(2)==u'{'):
                pass
                _saveIndex = self.text.length()
                self.match('\\')
                self.text.setLength(_saveIndex)
                self.match('{')
            elif (self.LA(1)==u'\\') and (_tokenSet_0.member(self.LA(2))):
                pass
                self.match('\\')
                self.matchNot('{')
            elif (_tokenSet_1.member(self.LA(1))):
                pass
                self.matchNot('{')
            else:
                break
            
            _cnt7 += 1
        if _cnt7 < 1:
            self.raise_NoViableAlt(self.LA(1))
        self.text.getString(_begin);
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mACTION(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = ACTION
        _saveIndex = 0
        if (self.LA(1)==u'{') and (self.LA(2)==u'e') and (self.LA(3)==u'l') and (self.LA(4)==u's') and (self.LA(5)==u'e') and (self.LA(6)==u'i'):
            pass
            _saveIndex = self.text.length()
            self.match("{elseif")
            self.text.setLength(_saveIndex)
            _cnt18= 0
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
                _cnt18 += 1
            if _cnt18 < 1:
                self.raise_NoViableAlt(self.LA(1))
            self.mIF_EXPR(False)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            _saveIndex = self.text.length()
            self.match('}')
            self.text.setLength(_saveIndex)
            _ttype = ELSEIF;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'e') and (self.LA(3)==u'l') and (self.LA(4)==u's') and (self.LA(5)==u'e') and (self.LA(6)==u'}'):
            pass
            _saveIndex = self.text.length()
            self.match("{else}")
            self.text.setLength(_saveIndex)
            _ttype = ELSE;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'i') and (self.LA(3)==u'f'):
            pass
            _saveIndex = self.text.length()
            self.match("{if")
            self.text.setLength(_saveIndex)
            _cnt14= 0
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
                _cnt14 += 1
            if _cnt14 < 1:
                self.raise_NoViableAlt(self.LA(1))
            self.mIF_EXPR(False)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            _saveIndex = self.text.length()
            self.match('}')
            self.text.setLength(_saveIndex)
            _ttype = IF;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'/') and (self.LA(3)==u'i'):
            pass
            _saveIndex = self.text.length()
            self.match("{/if}")
            self.text.setLength(_saveIndex)
            _ttype = ENDIF;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'/') and (self.LA(3)==u'f'):
            pass
            _saveIndex = self.text.length()
            self.match("{/foreach}")
            self.text.setLength(_saveIndex)
            _ttype = ENDFOR
        elif (self.LA(1)==u'{') and (self.LA(2)==u'i') and (self.LA(3)==u'n'):
            pass
            _saveIndex = self.text.length()
            self.match("{include")
            self.text.setLength(_saveIndex)
            _cnt26= 0
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
                _cnt26 += 1
            if _cnt26 < 1:
                self.raise_NoViableAlt(self.LA(1))
            self.mINC_EXPR(False)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            _saveIndex = self.text.length()
            self.match('}')
            self.text.setLength(_saveIndex)
            _ttype = INCLUDE;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'*'):
            pass
            self.mCOMMENT(False)
            _ttype = SKIP;
        elif (self.LA(1)==u'{') and (self.LA(2)==u' ' or self.LA(2)==u'$'):
            pass
            _saveIndex = self.text.length()
            self.match('{')
            self.text.setLength(_saveIndex)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            self.mEXPR(False)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            _saveIndex = self.text.length()
            self.match('}')
            self.text.setLength(_saveIndex)
            _ttype = EXPR;
        elif (self.LA(1)==u'{') and (self.LA(2)==u'f'):
            pass
            _saveIndex = self.text.length()
            self.match("{foreach")
            self.text.setLength(_saveIndex)
            _cnt22= 0
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
                _cnt22 += 1
            if _cnt22 < 1:
                self.raise_NoViableAlt(self.LA(1))
            self.mFOREACH_EXPR(False)
            while True:
                if (self.LA(1)==u' '):
                    pass
                    _saveIndex = self.text.length()
                    self.match(' ')
                    self.text.setLength(_saveIndex)
                else:
                    break
                
            _saveIndex = self.text.length()
            self.match('}')
            self.text.setLength(_saveIndex)
            _ttype = FOREACH;
        else:
            self.raise_NoViableAlt(self.LA(1))
        
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mCOMMENT(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = COMMENT
        _saveIndex = 0
        pass
        self.match("{*")
        while True:
            ###  nongreedy exit test
            if ((self.LA(1)==u'*') and (self.LA(2)==u'}') and (True)):
                break
            if (self.LA(1)==u'\n' or self.LA(1)==u'\r') and ((self.LA(2) >= u'\u0000' and self.LA(2) <= u'\ufffe')) and ((self.LA(3) >= u'\u0000' and self.LA(3) <= u'\ufffe')) and (True) and (True) and (True) and (True) and (True) and (True):
                pass
                self.mNL(False)
            elif ((self.LA(1) >= u'\u0000' and self.LA(1) <= u'\ufffe')) and ((self.LA(2) >= u'\u0000' and self.LA(2) <= u'\ufffe')) and ((self.LA(3) >= u'\u0000' and self.LA(3) <= u'\ufffe')) and (True) and (True) and (True) and (True) and (True) and (True):
                pass
                self.matchNot(antlr.EOF_CHAR)
            else:
                break
            
        self.match("*}")
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mEXPR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = EXPR
        _saveIndex = 0
        pass
        self.mVARIABLE(False)
        while True:
            if (self.LA(1)==u'|'):
                pass
                self.mFILTER(False)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mIF_EXPR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = IF_EXPR
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'!':
            pass
            self.match('!')
        elif la1 and la1 in u'$':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.mEXPR(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mFOREACH_EXPR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = FOREACH_EXPR
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'f':
            pass
            pass
            self.mLOOP_VAR(False)
        elif la1 and la1 in u'i':
            pass
            pass
            self.mLOOP_ITEM(False)
        elif la1 and la1 in u'n':
            pass
            pass
            self.mLOOP_NAME(False)
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            if (self.LA(1)==u' ') and (self.LA(2)==u'f' or self.LA(2)==u'i' or self.LA(2)==u'n'):
                pass
                pass
                self.match(' ')
                la1 = self.LA(1)
                if False:
                    pass
                elif la1 and la1 in u'f':
                    pass
                    pass
                    self.mLOOP_VAR(False)
                elif la1 and la1 in u'i':
                    pass
                    pass
                    self.mLOOP_ITEM(False)
                elif la1 and la1 in u'n':
                    pass
                    pass
                    self.mLOOP_NAME(False)
                else:
                        self.raise_NoViableAlt(self.LA(1))
                    
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mINC_EXPR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = INC_EXPR
        _saveIndex = 0
        pass
        self.match("file")
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.match('=')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'"':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.match('"')
        _cnt93= 0
        while True:
            if (_tokenSet_2.member(self.LA(1))):
                pass
                self.matchNot('"')
            else:
                break
            
            _cnt93 += 1
        if _cnt93 < 1:
            self.raise_NoViableAlt(self.LA(1))
        self.match('"')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNL(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NL
        _saveIndex = 0
        if (self.LA(1)==u'\r') and (self.LA(2)==u'\n') and ((self.LA(3) >= u'\u0000' and self.LA(3) <= u'\ufffe')) and ((self.LA(4) >= u'\u0000' and self.LA(4) <= u'\ufffe')) and (True) and (True) and (True) and (True) and (True):
            pass
            self.match('\r')
            self.match('\n')
        elif (self.LA(1)==u'\r') and ((self.LA(2) >= u'\u0000' and self.LA(2) <= u'\ufffe')) and ((self.LA(3) >= u'\u0000' and self.LA(3) <= u'\ufffe')) and (True) and (True) and (True) and (True) and (True) and (True):
            pass
            self.match('\r')
        elif (self.LA(1)==u'\n'):
            pass
            self.match('\n')
        else:
            self.raise_NoViableAlt(self.LA(1))
        
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mVARIABLE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = VARIABLE
        _saveIndex = 0
        pass
        self.match('$')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                pass
                self.matchRange(u'a', u'z')
            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                pass
                self.matchRange(u'A', u'Z')
            elif la1 and la1 in u'0123456789':
                pass
                self.matchRange(u'0', u'9')
            else:
                    break
                
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'.':
                pass
                pass
                self.match(".")
                la1 = self.LA(1)
                if False:
                    pass
                elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                    pass
                    self.matchRange(u'a', u'z')
                elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                    pass
                    self.matchRange(u'A', u'Z')
                else:
                        self.raise_NoViableAlt(self.LA(1))
                    
                while True:
                    la1 = self.LA(1)
                    if False:
                        pass
                    elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                        pass
                        self.matchRange(u'a', u'z')
                    elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                        pass
                        self.matchRange(u'A', u'Z')
                    elif la1 and la1 in u'0123456789':
                        pass
                        self.matchRange(u'0', u'9')
                    else:
                            break
                        
            elif la1 and la1 in u'[':
                pass
                pass
                self.match('[')
                _cnt62= 0
                while True:
                    if ((self.LA(1) >= u'0' and self.LA(1) <= u'9')):
                        pass
                        self.matchRange(u'0', u'9')
                    else:
                        break
                    
                    _cnt62 += 1
                if _cnt62 < 1:
                    self.raise_NoViableAlt(self.LA(1))
                self.match(']')
            else:
                    break
                
        _ttype = VARIABLE;
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mFILTER(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = FILTER
        _saveIndex = 0
        pass
        self.match('|')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                pass
                self.matchRange(u'a', u'z')
            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                pass
                self.matchRange(u'A', u'Z')
            elif la1 and la1 in u'0123456789':
                pass
                self.matchRange(u'0', u'9')
            else:
                    break
                
        while True:
            if (self.LA(1)==u':'):
                pass
                self.mFILTER_ARGS(False)
            else:
                break
            
        _ttype = FILTER;
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mFILTER_ARGS(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = FILTER_ARGS
        _saveIndex = 0
        pass
        self.match(':')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'"':
            pass
            pass
            self.match('"')
            pass
            self.matchNot('"')
            self.match('"')
        elif la1 and la1 in u'0123456789':
            pass
            pass
            _cnt50= 0
            while True:
                if ((self.LA(1) >= u'0' and self.LA(1) <= u'9')):
                    pass
                    self.matchRange(u'0', u'9')
                else:
                    break
                
                _cnt50 += 1
            if _cnt50 < 1:
                self.raise_NoViableAlt(self.LA(1))
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_VAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_VAR
        _saveIndex = 0
        pass
        self.match("from")
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.match('=')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'$':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.match('$')
        pass
        self.mSYMBOL(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_ITEM(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_ITEM
        _saveIndex = 0
        pass
        self.match("item")
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.match('=')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.mSYMBOL(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLOOP_NAME(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LOOP_NAME
        _saveIndex = 0
        pass
        self.match("name")
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'=':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.match('=')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.mSYMBOL(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSYMBOL(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = SYMBOL
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                pass
                self.matchRange(u'a', u'z')
            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                pass
                self.matchRange(u'A', u'Z')
            elif la1 and la1 in u'0123456789':
                pass
                self.matchRange(u'0', u'9')
            elif la1 and la1 in u'.':
                pass
                self.match('.')
            else:
                    break
                
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNO_ESC(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NO_ESC
        _saveIndex = 0
        pass
        if (_tokenSet_3.member(self.LA(1))):
            pass
            self.matchNot('\\')
        else: ## <m4>
                pass
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    

### generate bit set
def mk_tokenSet_0(): 
    data = [0L] * 2048 ### init list
    data[0] =-1L
    data[1] =-576460752303423489L
    for x in xrange(2, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())

### generate bit set
def mk_tokenSet_1(): 
    data = [0L] * 2048 ### init list
    data[0] =-1L
    data[1] =-576460752571858945L
    for x in xrange(2, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_1 = antlr.BitSet(mk_tokenSet_1())

### generate bit set
def mk_tokenSet_2(): 
    data = [0L] * 2048 ### init list
    data[0] =-17179869185L
    for x in xrange(1, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_2 = antlr.BitSet(mk_tokenSet_2())

### generate bit set
def mk_tokenSet_3(): 
    data = [0L] * 2048 ### init list
    data[0] =-1L
    data[1] =-268435457L
    for x in xrange(2, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_3 = antlr.BitSet(mk_tokenSet_3())
    
### __main__ header action >>> 
if __name__ == '__main__' :
    import sys
    import antlr
    import SmartyLexer
    
    ### create lexer - shall read from stdin
    try:
        for token in SmartyLexer.Lexer():
            print token
            
    except antlr.TokenStreamException, e:
        print "error: exception caught while lexing: ", e
### __main__ header action <<< 
