header {
import sys
from StringIO import StringIO
}
options {
    language = "Python";
}

class SmartyExprLexer extends Lexer;

options { k=5; }

FILTER : '|'! (SYMBOL)
        { $setType(FILTER); }
        ;
FILTER_ARGS : ':'! (('"'! (~'\"')+ '"'!)|('\''! (~'\'')+ '\''!))
        { $setType(FILTER_ARGS)}
        ;
VARIABLE : '$'! (SYMBOL)
           ("." (SYMBOL))*
        { $setType(VARIABLE); }
        ;
INDEX : ('['! ('0'..'9')+ ']'!);
LOOP_VAR : "from"! (' '!)? '='! (' '!)? VARIABLE (' '!)*
        ;
LOOP_ITEM : "item"! (' '!)? '='! (' '!)? (SYMBOL) (' '!)*
        ;
LOOP_KEY : "key"! (' '!)? '='! (' '!)? (SYMBOL) (' '!)*
        ;
LOOP_NAME : "name"! (' '!)? '='! (' '!)? (SYMBOL) (' '!)*
        ;

SYMBOL : ('a'..'z'|'A'..'Z')('a'..'z'|'A'..'Z'|'0'..'9')*
        ;
INC_EXPR : "file"! (' '!)? '='! (' '!)? '"'! (~'"')+ '"'!
;
