# coding:utf-8
from caty.shell.script import Command
from caty.util.collection import SortedList
from caty.util.creole import creole2html
from caty.jsontools.model import tagged
from itertools import islice
import os
from weblog import *
from wiki import *

class GenMenu(Command):
    def execute(self, opts):
        path = self.var.get('PATH')
        menu = [
            {'title': u'Top', 'link': u'/'},
            {'title': u'Blog', 'link': u'/blog/'},
            {'title': u'Wiki', 'link': u'/wiki/'},
        ]
        if path == '/':
            menu[0]['link'] = None
        elif path.startswith('/blog/'):
            menu[1]['link'] = None
        elif path.startswith('/wiki/'):
            menu[2]['link'] = None
        self.output = {"menu": menu}
        return 0

