### $ANTLR 2.7.7 (20090605): "jsonpath.g" -> "JsonPathLexer.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
class JsonPathError(Exception):
   pass
class Undefined(object):
   pass
undefined = Undefined()
### header action <<< 
### preamble action >>> 

### preamble action <<< 
### >>>The Literals<<<
literals = {}


### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
ROOT = 4
PATH = 5
SCHEMATYPE = 6
NAME = 7
NUMBER = 8
STRINGBLOCK = 9
NL = 10
WS = 11
CHAR = 12

class Lexer(antlr.CharScanner) :
    ### user action >>>
    ### user action <<<
    def __init__(self, *argv, **kwargs) :
        antlr.CharScanner.__init__(self, *argv, **kwargs)
        self.caseSensitiveLiterals = True
        self.setCaseSensitive(True)
        self.literals = literals
    
    def nextToken(self):
        while True:
            try: ### try again ..
                while True:
                    _token = None
                    _ttype = INVALID_TYPE
                    self.setCommitToPath(False)
                    self.resetText()
                    try: ## for char stream error handling
                        try: ##for lexical error handling
                            la1 = self.LA(1)
                            if False:
                                pass
                            elif la1 and la1 in u'$':
                                pass
                                self.mROOT(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'.':
                                pass
                                self.mPATH(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
                                pass
                                self.mNAME(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u':':
                                pass
                                self.mSCHEMATYPE(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'\n;':
                                pass
                                self.mNL(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'\t ':
                                pass
                                self.mWS(True)
                                theRetToken = self._returnToken
                            else:
                                    self.filterdefault(self.LA(1))
                                
                            if not self._returnToken:
                                raise antlr.TryAgain ### found SKIP token
                            ### option { testLiterals=true } 
                            self.testForLiteral(self._returnToken)
                            ### return token to caller
                            return self._returnToken
                        ### handle lexical errors ....
                        except antlr.RecognitionException, e:
                            if not self.getCommitToPath():
                                self.consume()
                                raise antlr.TryAgain()
                            raise antlr.TokenStreamRecognitionException(e)
                    ### handle char stream errors ...
                    except antlr.CharStreamException,cse:
                        if isinstance(cse, antlr.CharStreamIOException):
                            raise antlr.TokenStreamIOException(cse.io)
                        else:
                            raise antlr.TokenStreamException(str(cse))
            except antlr.TryAgain:
                pass
        
    def mROOT(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = ROOT
        _saveIndex = 0
        pass
        self.match('$')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mPATH(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = PATH
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match('.')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz':
            pass
            self.mNAME(False)
        elif la1 and la1 in u'*':
            pass
            self.match('*')
        elif la1 and la1 in u'#':
            pass
            self.match('#')
        elif la1 and la1 in u'0123456789':
            pass
            self.mNUMBER(False)
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNAME(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NAME
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
                pass
                self.matchRange(u'a', u'z')
            elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
                pass
                self.matchRange(u'A', u'Z')
            else:
                    break
                
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNUMBER(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NUMBER
        _saveIndex = 0
        pass
        pass
        self.matchRange(u'0', u'9')
        while True:
            if ((self.LA(1) >= u'0' and self.LA(1) <= u'9')):
                pass
                self.matchRange(u'0', u'9')
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSCHEMATYPE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = SCHEMATYPE
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match(':')
        self.text.setLength(_saveIndex)
        self.mSTRINGBLOCK(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSTRINGBLOCK(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = STRINGBLOCK
        _saveIndex = 0
        pass
        _cnt18= 0
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                self.mCHAR(False)
            else:
                break
            
            _cnt18 += 1
        if _cnt18 < 1:
            self.raise_NoViableAlt(self.LA(1))
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mCHAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = CHAR
        _saveIndex = 0
        pass
        self.match(_tokenSet_0)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNL(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NL
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'\n':
            pass
            self.match('\n')
        elif la1 and la1 in u';':
            pass
            self.match(';')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _ttype = SKIP
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mWS(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = WS
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u'\t':
            pass
            self.match('\t')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        _ttype = SKIP
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    

### generate bit set
def mk_tokenSet_0(): 
    data = [0L] * 2048 ### init list
    data[0] =-576460752303424513L
    for x in xrange(1, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())
    
### __main__ header action >>> 
if __name__ == '__main__' :
    import sys
    import antlr
    import JsonPathLexer
    
    ### create lexer - shall read from stdin
    try:
        for token in JsonPathLexer.Lexer():
            print token
            
    except antlr.TokenStreamException, e:
        print "error: exception caught while lexing: ", e
### __main__ header action <<< 
