### $ANTLR 2.7.7 (20090605): "jsonschema.g" -> "JsonSchemaParser.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
from caty.jsontools.schema.language.ast import *
### header action <<< 
### preamble action>>>

### preamble action <<<

### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
LITERAL_type = 4
SYMBOL = 5
EQUAL = 6
DELIM = 7
TAG = 8
OR = 9
AND = 10
LITERAL_object = 11
LBRACE = 12
COMMA = 13
RBRACE = 14
ASTER = 15
STRING = 16
COLON = 17
OPTIONAL = 18
LPAREN = 19
RPAREN = 20
LBRACKET = 21
RBRACKET = 22
NUMBER = 23
INLINECOMMENT = 24
MULTILINECOMMENT = 25
TOKEN = 26
WS = 27

class Parser(antlr.LLkParser):
    ### user action >>>
    ### user action <<<
    
    def __init__(self, *args, **kwargs):
        antlr.LLkParser.__init__(self, *args, **kwargs)
        self.tokenNames = _tokenNames
        
    def parse_schema(self):    
        r = None
        
        t = None
        try:      ## for error handling
            pass
            r=[]
            while True:
                if (self.LA(1)==LITERAL_type):
                    pass
                    self.match(LITERAL_type)
                    t = self.LT(1)
                    self.match(SYMBOL)
                    self.match(EQUAL)
                    s=self.schema_def()
                    self.match(DELIM)
                    r.append(RootNode(t, s))
                else:
                    break
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_0)
        
        return r
    
    def schema_def(self):    
        r = None
        
        t = None
        try:      ## for error handling
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [TAG]:
                pass
                self.match(TAG)
                t = self.LT(1)
                self.match(SYMBOL)
                d=self.schema_def()
                r=TaggedNode(t, d)
            elif la1 and la1 in [SYMBOL,LITERAL_object]:
                pass
                s=None; c=None
                s=self.schema_def2()
                la1 = self.LA(1)
                if False:
                    pass
                elif la1 and la1 in [OR,AND]:
                    pass
                    c=self.combined_schemadef()
                elif la1 and la1 in [DELIM,COMMA,RBRACE]:
                    pass
                else:
                        raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                    
                if not c:
                   r = s
                else:
                   r = c[0](s, c[1])
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_1)
        
        return r
    
    def schema_def2(self):    
        r = None
        
        s = None
        try:      ## for error handling
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [LITERAL_object]:
                pass
                oi = []
                pass
                self.match(LITERAL_object)
                self.match(LBRACE)
                x=self.objitem()
                oi.append(x)
                while True:
                    if (self.LA(1)==COMMA):
                        pass
                        self.match(COMMA)
                        o=self.objitem()
                        oi.append(o)
                    else:
                        break
                    
                self.match(RBRACE)
                op=self.optional()
                items=dict(oi)
                if "*" in items:
                   wildcard=items["*"]
                   items.pop("*")
                else:
                   wildcard=None
                o = ObjectNode(items, wildcard)
                if op:
                   o.optional = True
                r=o
            elif la1 and la1 in [SYMBOL]:
                pass
                pass
                s = self.LT(1)
                self.match(SYMBOL)
                o=self.option()
                u=self.underlyingtypes()
                op=self.optional()
                r = ScalarNode(s.getText())
                r.options = o if o else {}
                udt = []
                for s, o in u:
                   if o:
                       r.options["repeat"] = True
                   udt.append(s)
                r.underlyingtypes = udt
                if op:
                   r.optional = True
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_2)
        
        return r
    
    def combined_schemadef(self):    
        r = None
        
        o = None
        a = None
        try:      ## for error handling
            pass
            o=None; a=None; s=None; c=None
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [OR]:
                pass
                o = self.LT(1)
                self.match(OR)
            elif la1 and la1 in [AND]:
                pass
                a = self.LT(1)
                self.match(AND)
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
            s=self.schema_def2()
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [OR,AND]:
                pass
                c=self.combined_schemadef()
            elif la1 and la1 in [DELIM,COMMA,RBRACE]:
                pass
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
            if o:
               combine = UnionNode
            else:
               combine = IntersectionNode
            if not c:
               r = combine, s
            else:
               c2, s2 = c
               newnode = c2(s, s2)
               r = combine, newnode
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_1)
        
        return r
    
    def objitem(self):    
        r = None
        
        a = None
        k = None
        try:      ## for error handling
            pass
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [ASTER]:
                pass
                a = self.LT(1)
                self.match(ASTER)
            elif la1 and la1 in [STRING]:
                pass
                k = self.LT(1)
                self.match(STRING)
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
            self.match(COLON)
            s=self.schema_def()
            r = k.getText() if k else a.getText(), s
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_3)
        
        return r
    
    def optional(self):    
        r = None
        
        o = None
        try:      ## for error handling
            pass
            r=False
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [OPTIONAL]:
                pass
                o = self.LT(1)
                self.match(OPTIONAL)
                r = True if o else False
            elif la1 and la1 in [DELIM,OR,AND,COMMA,RBRACE]:
                pass
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_2)
        
        return r
    
    def option(self):    
        r = None
        
        try:      ## for error handling
            pass
            r=[]
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [LPAREN]:
                pass
                self.match(LPAREN)
                o=self.optvalue()
                r.append(o)
                while True:
                    if (self.LA(1)==COMMA):
                        pass
                        self.match(COMMA)
                        v=self.optvalue()
                        r.append(v)
                    else:
                        break
                    
                self.match(RPAREN)
                
            elif la1 and la1 in [DELIM,OR,AND,COMMA,RBRACE,OPTIONAL,LBRACKET]:
                pass
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_4)
        
        return r
    
    def underlyingtypes(self):    
        r = None
        
        try:      ## for error handling
            pass
            r=[]
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [LBRACKET]:
                pass
                self.match(LBRACKET)
                a=self.scalar()
                r.append(a)
                while True:
                    if (self.LA(1)==COMMA):
                        pass
                        self.match(COMMA)
                        t=self.scalar()
                        r.append(t)
                    else:
                        break
                    
                self.match(RBRACKET)
            elif la1 and la1 in [DELIM,OR,AND,COMMA,RBRACE,OPTIONAL]:
                pass
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_5)
        
        return r
    
    def optvalue(self):    
        r = None
        
        k = None
        v = None
        i = None
        try:      ## for error handling
            pass
            k = self.LT(1)
            self.match(SYMBOL)
            self.match(EQUAL)
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [STRING]:
                pass
                v = self.LT(1)
                self.match(STRING)
            elif la1 and la1 in [NUMBER]:
                pass
                i = self.LT(1)
                self.match(NUMBER)
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
            r = (k.getText(), v.gettext() if v else int(i.getText()))
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_6)
        
        return r
    
    def scalar(self):    
        r = None
        
        s = None
        a = None
        o = None
        try:      ## for error handling
            pass
            s = self.LT(1)
            self.match(SYMBOL)
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in [ASTER]:
                pass
                a = self.LT(1)
                self.match(ASTER)
            elif la1 and la1 in [OPTIONAL]:
                pass
                o = self.LT(1)
                self.match(OPTIONAL)
            elif la1 and la1 in [COMMA,RBRACKET]:
                pass
            else:
                    raise antlr.NoViableAltException(self.LT(1), self.getFilename())
                
            x = ScalarNode(s.getText())
            if o:
               x.optional = True
            r = x, a
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_7)
        
        return r
    

_tokenNames = [
    "<0>", 
    "EOF", 
    "<2>", 
    "NULL_TREE_LOOKAHEAD", 
    "\"type\"", 
    "SYMBOL", 
    "EQUAL", 
    "DELIM", 
    "TAG", 
    "OR", 
    "AND", 
    "\"object\"", 
    "LBRACE", 
    "COMMA", 
    "RBRACE", 
    "ASTER", 
    "STRING", 
    "COLON", 
    "OPTIONAL", 
    "LPAREN", 
    "RPAREN", 
    "LBRACKET", 
    "RBRACKET", 
    "NUMBER", 
    "INLINECOMMENT", 
    "MULTILINECOMMENT", 
    "TOKEN", 
    "WS"
]
    

### generate bit set
def mk_tokenSet_0(): 
    ### var1
    data = [ 2L, 0L]
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())

### generate bit set
def mk_tokenSet_1(): 
    ### var1
    data = [ 24704L, 0L]
    return data
_tokenSet_1 = antlr.BitSet(mk_tokenSet_1())

### generate bit set
def mk_tokenSet_2(): 
    ### var1
    data = [ 26240L, 0L]
    return data
_tokenSet_2 = antlr.BitSet(mk_tokenSet_2())

### generate bit set
def mk_tokenSet_3(): 
    ### var1
    data = [ 24576L, 0L]
    return data
_tokenSet_3 = antlr.BitSet(mk_tokenSet_3())

### generate bit set
def mk_tokenSet_4(): 
    ### var1
    data = [ 2385536L, 0L]
    return data
_tokenSet_4 = antlr.BitSet(mk_tokenSet_4())

### generate bit set
def mk_tokenSet_5(): 
    ### var1
    data = [ 288384L, 0L]
    return data
_tokenSet_5 = antlr.BitSet(mk_tokenSet_5())

### generate bit set
def mk_tokenSet_6(): 
    ### var1
    data = [ 1056768L, 0L]
    return data
_tokenSet_6 = antlr.BitSet(mk_tokenSet_6())

### generate bit set
def mk_tokenSet_7(): 
    ### var1
    data = [ 4202496L, 0L]
    return data
_tokenSet_7 = antlr.BitSet(mk_tokenSet_7())
    
