# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.jsontools.schema import *
from caty.testutil import TestCase

class ListSchemaTest(TestCase):
    def test_validate_ok(self):
        scm = ListSchema(optional=True)._apply_udt([NumberSchema(is_integer=True)])
        try:
            scm.validate([])
            scm.validate([0])
            scm.validate(range(10))
        except Exception, e:
            self.fail(e)

    def test_type_error(self):
        scm = ListSchema(optional=True)._apply_udt([NumberSchema(is_integer=True)])
        self.assertRaises(JsonSchemaError, scm.validate, [u'a', u'b', 1])
        self.assertRaises(JsonSchemaError, scm.validate, [True])
        self.assertRaises(JsonSchemaError, scm.validate, u'a')

    def test_convert(self):
        scm = ListSchema(optional=True)._apply_udt([NumberSchema(is_integer=True)])
        converted = [1]
        converted = scm.convert(['1'])



