### $ANTLR 2.7.7 (20090605): "script.g" -> "CatyScriptLexer.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
class ScriptSyntaxError(Exception):
   pass
### header action <<< 
### preamble action >>> 

### preamble action <<< 
### >>>The Literals<<<
literals = {}


### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
LBRACE = 4
RBRACE = 5
LBRACKET = 6
RBRACKET = 7
OPTION = 8
SHORTOPT = 9
LONGOPT = 10
STRING = 11
QSTRING = 12
SUBSTITUTION = 13
LSUBSTITUTION = 14
PIPE = 15
COMMA = 16
LPAREN = 17
RPAREN = 18
CASE = 19
DELIMTAGCASE = 20
WS = 21
LF = 22
NUMBER = 23
CHAR = 24
NO_NUM_CHAR = 25
ESCAPEDCHAR = 26

class Lexer(antlr.CharScanner) :
    ### user action >>>
    ### user action <<<
    def __init__(self, *argv, **kwargs) :
        antlr.CharScanner.__init__(self, *argv, **kwargs)
        self.caseSensitiveLiterals = True
        self.setCaseSensitive(True)
        self.literals = literals
    
    def nextToken(self):
        while True:
            try: ### try again ..
                while True:
                    _token = None
                    _ttype = INVALID_TYPE
                    self.setCommitToPath(False)
                    self.resetText()
                    try: ## for char stream error handling
                        try: ##for lexical error handling
                            la1 = self.LA(1)
                            if False:
                                pass
                            elif la1 and la1 in u'{':
                                pass
                                self.mLBRACE(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'}':
                                pass
                                self.mRBRACE(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'[':
                                pass
                                self.mLBRACKET(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u']':
                                pass
                                self.mRBRACKET(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'"':
                                pass
                                self.mQSTRING(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u':':
                                pass
                                self.mSUBSTITUTION(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'>':
                                pass
                                self.mLSUBSTITUTION(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'|':
                                pass
                                self.mPIPE(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u',':
                                pass
                                self.mCOMMA(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'(':
                                pass
                                self.mLPAREN(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u')':
                                pass
                                self.mRPAREN(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u' ':
                                pass
                                self.mWS(True)
                                theRetToken = self._returnToken
                            elif la1 and la1 in u'\n':
                                pass
                                self.mLF(True)
                                theRetToken = self._returnToken
                            else:
                                if (self.LA(1)==u'=') and (self.LA(2)==u'>') and (self.LA(3)==u'>'):
                                    pass
                                    self.mDELIMTAGCASE(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'-') and (_tokenSet_0.member(self.LA(2))):
                                    pass
                                    self.mOPTION(True)
                                    theRetToken = self._returnToken
                                elif (self.LA(1)==u'=') and (self.LA(2)==u'>') and (True):
                                    pass
                                    self.mCASE(True)
                                    theRetToken = self._returnToken
                                elif (_tokenSet_1.member(self.LA(1))):
                                    pass
                                    self.mSTRING(True)
                                    theRetToken = self._returnToken
                                elif (_tokenSet_2.member(self.LA(1))) and (True):
                                    pass
                                    self.mNUMBER(True)
                                    theRetToken = self._returnToken
                                else:
                                    self.filterdefault(self.LA(1))
                                
                            if not self._returnToken:
                                raise antlr.TryAgain ### found SKIP token
                            ### option { testLiterals=true } 
                            self.testForLiteral(self._returnToken)
                            ### return token to caller
                            return self._returnToken
                        ### handle lexical errors ....
                        except antlr.RecognitionException, e:
                            if not self.getCommitToPath():
                                self.consume()
                                raise antlr.TryAgain()
                            raise antlr.TokenStreamRecognitionException(e)
                    ### handle char stream errors ...
                    except antlr.CharStreamException,cse:
                        if isinstance(cse, antlr.CharStreamIOException):
                            raise antlr.TokenStreamIOException(cse.io)
                        else:
                            raise antlr.TokenStreamException(str(cse))
            except antlr.TryAgain:
                pass
        
    def mLBRACE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LBRACE
        _saveIndex = 0
        pass
        self.match('{')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mRBRACE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = RBRACE
        _saveIndex = 0
        pass
        self.match('}')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLBRACKET(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LBRACKET
        _saveIndex = 0
        pass
        self.match('[')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mRBRACKET(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = RBRACKET
        _saveIndex = 0
        pass
        self.match(']')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mOPTION(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = OPTION
        _saveIndex = 0
        if (self.LA(1)==u'-') and (_tokenSet_3.member(self.LA(2))):
            pass
            self.mSHORTOPT(False)
        elif (self.LA(1)==u'-') and (self.LA(2)==u'-'):
            pass
            self.mLONGOPT(False)
        else:
            self.raise_NoViableAlt(self.LA(1))
        
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSHORTOPT(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = SHORTOPT
        _saveIndex = 0
        pass
        self.match('-')
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'abcdefghijklmnopqrstuvwxyz':
            pass
            self.matchRange(u'a', u'z')
        elif la1 and la1 in u'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
            pass
            self.matchRange(u'A', u'Z')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLONGOPT(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LONGOPT
        _saveIndex = 0
        pass
        self.match("--")
        self.mSTRING(False)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSTRING(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = STRING
        _saveIndex = 0
        pass
        if (self.LA(1)==u'\\') and (_tokenSet_4.member(self.LA(2))):
            pass
            self.mESCAPEDCHAR(False)
        elif (_tokenSet_1.member(self.LA(1))) and (True):
            pass
            self.mNO_NUM_CHAR(False)
        else:
            self.raise_NoViableAlt(self.LA(1))
        
        while True:
            if (self.LA(1)==u'\\') and (_tokenSet_4.member(self.LA(2))):
                pass
                self.mESCAPEDCHAR(False)
            elif (_tokenSet_5.member(self.LA(1))) and (True):
                pass
                self.mCHAR(False)
            else:
                break
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNO_NUM_CHAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NO_NUM_CHAR
        _saveIndex = 0
        pass
        self.match(_tokenSet_1)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mESCAPEDCHAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = ESCAPEDCHAR
        _saveIndex = 0
        pass
        _saveIndex = self.text.length()
        self.match('\\')
        self.text.setLength(_saveIndex)
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'(':
            pass
            self.match('(')
        elif la1 and la1 in u')':
            pass
            self.match(')')
        elif la1 and la1 in u'{':
            pass
            self.match('{')
        elif la1 and la1 in u'}':
            pass
            self.match('}')
        elif la1 and la1 in u'|':
            pass
            self.match('|')
        elif la1 and la1 in u' ':
            pass
            self.match(' ')
        elif la1 and la1 in u':':
            pass
            self.match(':')
        elif la1 and la1 in u'>':
            pass
            self.match('>')
        elif la1 and la1 in u'<':
            pass
            self.match('<')
        elif la1 and la1 in u'"':
            pass
            self.match('"')
        elif la1 and la1 in u',':
            pass
            self.match(',')
        elif la1 and la1 in u'=':
            pass
            self.match('=')
        elif la1 and la1 in u'[':
            pass
            self.match('[')
        elif la1 and la1 in u']':
            pass
            self.match(']')
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mCHAR(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = CHAR
        _saveIndex = 0
        pass
        self.match(_tokenSet_5)
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mQSTRING(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = QSTRING
        _saveIndex = 0
        pass
        pass
        self.match('"')
        while True:
            if (_tokenSet_6.member(self.LA(1))):
                pass
                self.matchNot('"')
            else:
                break
            
        pass
        self.match('"')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mSUBSTITUTION(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = SUBSTITUTION
        _saveIndex = 0
        pass
        self.match(':')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLSUBSTITUTION(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LSUBSTITUTION
        _saveIndex = 0
        pass
        self.match(">:")
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mPIPE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = PIPE
        _saveIndex = 0
        pass
        self.match('|')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mCOMMA(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = COMMA
        _saveIndex = 0
        pass
        self.match(',')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLPAREN(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LPAREN
        _saveIndex = 0
        pass
        self.match('(')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mRPAREN(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = RPAREN
        _saveIndex = 0
        pass
        self.match(')')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mCASE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = CASE
        _saveIndex = 0
        pass
        self.match("=>")
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mDELIMTAGCASE(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = DELIMTAGCASE
        _saveIndex = 0
        pass
        self.match("=>>")
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mWS(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = WS
        _saveIndex = 0
        pass
        pass
        self.match(' ')
        _ttype = SKIP;
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mLF(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = LF
        _saveIndex = 0
        pass
        self.match('\n')
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    def mNUMBER(self, _createToken):    
        _ttype = 0
        _token = None
        _begin = self.text.length()
        _ttype = NUMBER
        _saveIndex = 0
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in u'-':
            pass
            self.match('-')
        elif la1 and la1 in u'123456789':
            pass
        else:
                self.raise_NoViableAlt(self.LA(1))
            
        pass
        self.matchRange(u'1', u'9')
        while True:
            la1 = self.LA(1)
            if False:
                pass
            elif la1 and la1 in u'.':
                pass
                self.match('.')
            elif la1 and la1 in u'0123456789':
                pass
                self.matchRange(u'0', u'9')
            else:
                    break
                
        self.set_return_token(_createToken, _token, _ttype, _begin)
    
    

### generate bit set
def mk_tokenSet_0(): 
    data = [0L] * 1025 ### init list
    data[0] =35184372088832L
    data[1] =576460743847706622L
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())

### generate bit set
def mk_tokenSet_1(): 
    data = [0L] * 2048 ### init list
    data[0] =-8646685906142495745L
    data[1] =-4035225266795053057L
    for x in xrange(2, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_1 = antlr.BitSet(mk_tokenSet_1())

### generate bit set
def mk_tokenSet_2(): 
    data = [0L] * 1025 ### init list
    data[0] =287702610570379264L
    return data
_tokenSet_2 = antlr.BitSet(mk_tokenSet_2())

### generate bit set
def mk_tokenSet_3(): 
    data = [0L] * 1025 ### init list
    data[1] =576460743847706622L
    return data
_tokenSet_3 = antlr.BitSet(mk_tokenSet_3())

### generate bit set
def mk_tokenSet_4(): 
    data = [0L] * 1025 ### init list
    data[0] =8358701820595404800L
    data[1] =4035225266795053056L
    return data
_tokenSet_4 = antlr.BitSet(mk_tokenSet_4())

### generate bit set
def mk_tokenSet_5(): 
    data = [0L] * 2048 ### init list
    data[0] =-8358701820595405825L
    data[1] =-4035225266795053057L
    for x in xrange(2, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_5 = antlr.BitSet(mk_tokenSet_5())

### generate bit set
def mk_tokenSet_6(): 
    data = [0L] * 2048 ### init list
    data[0] =-17179869185L
    for x in xrange(1, 1023):
        data[x] = -1L
    data[1023] =9223372036854775807L
    return data
_tokenSet_6 = antlr.BitSet(mk_tokenSet_6())
    
### __main__ header action >>> 
if __name__ == '__main__' :
    import sys
    import antlr
    import CatyScriptLexer
    
    ### create lexer - shall read from stdin
    try:
        for token in CatyScriptLexer.Lexer():
            print token
            
    except antlr.TokenStreamException, e:
        print "error: exception caught while lexing: ", e
### __main__ header action <<< 
