# -*- coding: utf-8 -*-
from caty.shell.script import Command
import os
from StringIO import StringIO
import csv

# command csvToJson [string] :: 
#     void -> 
#     object{"data" : list [list [(string|number)]], "title": string}
class CsvToJson(Command):
    def execute(self, opts, path):
        title = os.path.basename(path)
        d = self.mafs.open(path).read()
        csvrdr = csv.reader(StringIO(d))

        r = {'data': [rec for rec in csvrdr], 'title': title}
        self.output = r

